theory Container_Setup
imports 
  "$AFP/Abstract-Rewriting/SN_Order_Carrier"
  Linear_Polynomial
  Mini_Algebraic_Numbers
  Linear_Orders
  Forbidden_Patterns
  "$AFP/Containers/Containers" 
begin

(* term, etc *)

derive (eq) ceq "term"
derive (linorder) corder "term"
derive (rbt) set_impl "term"
derive (no) cenum "term"

derive (eq) ceq lab
derive (linorder) corder lab
derive (rbt) set_impl lab
derive (no) cenum lab

derive (eq) ceq ctxt
derive corder ctxt
derive (rbt) set_impl ctxt
derive (no) cenum ctxt

derive (eq) ceq location
derive corder location
derive (dlist) set_impl location
derive (no) cenum location

(* rat *)

derive (eq) ceq rat
derive (no) cenum rat
derive (linorder) corder rat
derive (rbt) set_impl rat

(* mini_algebraic_number *)

derive (eq) ceq mini_alg_number
derive corder mini_alg_number (* here, we do not reuse the existing linorder, as the generated one
  is more efficient to compute *)
derive (rbt) set_impl mini_alg_number
derive (no) cenum mini_alg_number

(* l_poly *)
derive (eq) ceq l_poly
derive corder l_poly
derive (rbt) set_impl l_poly
derive (no) cenum l_poly

(* arctic and arctic_rat *)

derive (eq) ceq arctic
derive corder arctic
derive (rbt) set_impl arctic
derive (no) cenum arctic

derive (eq) ceq arctic_delta
derive corder arctic_delta
derive (rbt) set_impl arctic_delta
derive (no) cenum arctic_delta

(* code equation to handle Un *)
lemma un_foldr[code_unfold]: "\<Union> (set xs) = foldr (op \<union>) xs {}"
  by (induct xs, auto)

end
